//FirstView Component Constructor
var tblPartsList;
function FirstView() {
	var searchedResult = [];
	var cwin = Ti.UI.createWindow({
		title : 'Sample Window'
	});
	var loadButton = Ti.UI.createButton({
		title : 'Load More',
		height : '50dp',
		top : '10dp',
		backgroundColor : 'green'
	});
	tblPartsList = Ti.UI.createTableView({
		headerTitleId : 'Sample Table View',
		width : '100%',
		top : '50dp',
		bottom : '15dp',
	});

	var cData = generateRamdomArray();
	searchedResult = searchedResult.concat(cData);
	tblPartsList.data = [];
	tblPartsList.data = searchedResult;
	tblPartsList.addEventListener('click', function(e) {
		Ti.API.info("cell clicked " + JSON.stringify(e.row.cellId));

		if (e.row.cellId === 'xxx') {
			Ti.API.info("click on load more");
			var cData = generateRamdomArray();
			if (searchedResult && searchedResult.length > 0) {
				searchedResult.pop();
			}

			searchedResult = searchedResult.concat(cData);
			tblPartsList.data = [];
			tblPartsList.data = searchedResult;
			//Ti.API.info("table view " + JSON.stringify(tblPartsList));
			Ti.API.info("searchedResult count  " + searchedResult.length);
		}

	});

	tblPartsList.addEventListener('scroll', function(e) {
		//Ti.API.info("scroll " + e);
		
		//TODO: Want to get below values
		// var contentOffsetY = e.contentOffset.y;
		// var contentSizeHeight = e.contentSize.height;
		
		for (var key in e) {
			// skip loop if the property is from prototype
			if (!e.hasOwnProperty(key))
				continue;
			Ti.API.info("key " + key);
			var obj = e[key];
			for (var prop in obj) {
				// skip loop if the property is from prototype
				if (!obj.hasOwnProperty(prop))
					continue;

				// your code
				//Ti.API.info(prop + " = " + obj[prop]);
				
				// if(prop === "rect"){
					// Ti.API.info(prop + " = " + JSON.stringify(obj[prop]));
				// }
// 				
				// if(prop === "size"){
					// Ti.API.info(prop + " = " + JSON.stringify(obj[prop]));
				// }
// 				
				// if(prop === "center"){
					// Ti.API.info(prop + " = " + JSON.stringify(obj[prop]));
				// }
// 				
				// if(prop === "viewShadowOffset"){
					// Ti.API.info(prop + " = " + JSON.stringify(obj[prop]));
				// }
// 				
				// if(prop === "anchorPoint"){
					// Ti.API.info(prop + " = " + JSON.stringify(obj[prop]));
				// }
				
				Ti.API.info("************************************************");
			}
		}

	});

	loadButton.addEventListener('click', function(e) {
		Ti.API.info("Click");
		var cData = generateRamdomArray();
		if (searchedResult && searchedResult.length > 0) {
			searchedResult.pop();
		}

		searchedResult = searchedResult.concat(cData);
		tblPartsList.data = [];
		tblPartsList.data = searchedResult;
		//Ti.API.info("table view " + JSON.stringify(tblPartsList));
		Ti.API.info("searchedResult count  " + searchedResult.length);
	});

	function generateRamdomArray() {
		var data = [];
		for (var i = 0; i < 20; i++) {
			var cView = Ti.UI.createTableViewRow({
				height : Ti.UI.SIZE,
				cellId : Math.floor((Math.random() * 100) + 1)
			});
			var lblItemIDVal = Ti.UI.createLabel({
				width : '20%',
				height : 50,
				text : Math.floor((Math.random() * 100) + 1),
				color : 'black',
				wordWrap : true,
				left : '2%',
				backgroundColor : 'yellow',
			});
			cView.add(lblItemIDVal);
			data.push(cView);
		};

		var endCellView = Ti.UI.createTableViewRow({
			height : Ti.UI.SIZE,
			cellId : "xxx"
		});
		var endCellLabel = Ti.UI.createLabel({
			width : '20%',
			height : 50,
			text : 'Load More Items',
			color : 'black',
			wordWrap : true,
			left : '2%',
			backgroundColor : 'yellow',
		});
		endCellView.add(endCellLabel);
		data.push(endCellView);
		return data;
	}


	cwin.add(loadButton);
	cwin.add(tblPartsList);
	return cwin;
}

module.exports = FirstView;
